/* RoboDog.c */ 
#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include <KCG/SCADEMODELNAME.h>


/* 
 * Functions to return sensor values  

	x = ecrobot_get_sonar_sensor(NXT_PORT_S1); // 0 -> 255 (255 - Distance in CM)
	y = ecrobot_get_light_sensor(NXT_PORT_S2); // 0 (dark) -> 1024 (bright)
	z = ecrobot_get_touch_sensor(NXT_PORT_S3); // 0 -> untouched, 1 -> Touched
	w= ecrobot_get_sound_sensor(NXT_PORT_S4); // 1024 (quiet) -> 0 (loud) 

	w,x,y,z have to be integers
*/

/* 
 * Functions to set motor values: 

	nxt_motor_set_speed(NXT_PORT_A, RightValue, 1); // sets right motor t0 RightValue 
	nxt_motor_set_speed(NXT_PORT_B, LeftValue, 1); // sets left motor to LeftValue

	RightValue and LeftValue have to be integers
*/


/* 
 * Functions to output something on the display 

	display_clear(0); // clears the display
	display_goto_xy(0, 0); // moves pointer to a certain position on the this display 
	                          0,0 => first line, 0,1 => second line etc.
	display_string("some sting"); // display string at the current position
	display_int(someInt, 0); // display some int at the current position 
	display_update(); // updates display, mandatory to commit changes

	// example:
	display_clear(0);
	display_goto_xy(0, 0);
   	display_string("Hello World!");
	display_update();

*/



/* nxtOSEK hook to be invoked from an ISR in category 2 
 * this function is mandatory, do not change it */
void user_1ms_isr_type2(void){ /* do nothing */ }

/* Rover MainTask */
TASK(OSEK_Task_Background)
{
	
	/* result stores the outputs of the statemachine */
	outC_SCADEOPERATOR result;


	/* Reset StateMachine */
	SCADEOPERATOR_reset(&result);

	/* Init SonarSensor, also mandatory */
	ecrobot_init_sonar_sensor(NXT_PORT_S1);			
	
	
	
	while(1)
	{
		
		/* this function computes next step, returns current outputs */
		SCADEOPERATOR(&result);
		
		
		
		/* do something here */

		/* wait for sone_int_value msec */
		systick_wait_ms(some_int_value); 				
	}
}


